<template>
  <q-dialog :value="showSettings">
    <q-card style="min-width: 300px">
      <q-card-section>
        <q-item-label header>Settings</q-item-label>
      </q-card-section>

      <q-card-section>
        <div class="settingContainer">
          <q-list>
            <q-item>
              <q-item-label header>Show roomnumber?</q-item-label>
              <q-toggle
                v-model="config.showNumber"
                checked-icon="check"
                color="positive"
                unchecked-icon="clear"
              />
            </q-item>
            <q-item>
              <q-item-label header>Show facilities?</q-item-label>
              <q-toggle
                v-model="config.showFacilities"
                checked-icon="check"
                color="positive"
                unchecked-icon="clear"
              />
            </q-item>
            <q-item>
              <q-item-label header>Show patient's picture?</q-item-label>
              <q-toggle
                v-model="config.showPic"
                checked-icon="check"
                color="positive"
                unchecked-icon="clear"
              />
            </q-item>
            <q-item>
              <q-item-label header>Show monitoring data?</q-item-label>
              <q-toggle
                v-model="config.showMonitoring"
                checked-icon="check"
                color="positive"
                unchecked-icon="clear"
              />
            </q-item>
            <q-item>
              <q-item-label header>Show next action?</q-item-label>
              <q-toggle
                v-model="config.showNextAction"
                checked-icon="check"
                color="positive"
                unchecked-icon="clear"
              />
            </q-item>
            <q-item>
              <q-item-label header>Sound emergency alarm?</q-item-label>
              <q-toggle
                v-model="config.alarm"
                checked-icon="check"
                color="positive"
                unchecked-icon="clear"
              />
            </q-item>
            <q-item>
              <q-item-label header>Update heartrate threshold</q-item-label>
              <q-input
                v-model="config.heartrate.lower"
                label="Min Value"
                autofocus
                dense
              />
              <q-input
                :style="{margin: '10px'}"
                v-model="config.heartrate.upper"
                label="Max Value"
                autofocus
                dense
              />
            </q-item>
            <q-item>
              <q-item-label header>Update bloodpressure threshold</q-item-label>
              <q-input
                v-model="config.bloodpressure.lower"
                label="Min Value"
                autofocus
                dense
              />
              <q-input
                :style="{margin: '10px'}"
                v-model="config.bloodpressure.upper"
                label="Max Value"
                autofocus
                dense
              />
            </q-item>
            <q-item>
              <q-item-label header>Give the hour treshold before the warning color is applied (in minutes)</q-item-label>
              <q-input
                :style="{margin: '10px'}"
                v-model="config.hoursTreshold"
                label="Hours before next action"
                autofocus
                dense
              />
            </q-item>
            <q-item>
              <q-item-label header>Choose the color of a free room</q-item-label>

              <q-input
                filled
                v-model="config.free"
                class="my-input"
              >
                <template v-slot:append>
                  <q-icon
                    name="colorize"
                    class="cursor-pointer"
                  >
                    <q-popup-proxy
                      transition-show="scale"
                      transition-hide="scale"
                    >
                      <q-color v-model="config.free" />
                    </q-popup-proxy>
                  </q-icon>
                </template>
              </q-input>
            </q-item>
            <q-item>
              <q-item-label header>Choose the color of an occupied room</q-item-label>
              <q-input
                filled
                v-model="config.occupied"
                class="my-input"
              >
                <template v-slot:append>
                  <q-icon
                    name="colorize"
                    class="cursor-pointer"
                  >
                    <q-popup-proxy
                      transition-show="scale"
                      transition-hide="scale"
                    >
                      <q-color v-model="config.occupied" />
                    </q-popup-proxy>
                  </q-icon>
                </template>
              </q-input>
            </q-item>
            <q-item>
              <q-item-label header>Choose the color of an approaching action</q-item-label>
              <q-input
                filled
                v-model="config.warning"
                class="my-input"
              >
                <template v-slot:append>
                  <q-icon
                    name="colorize"
                    class="cursor-pointer"
                  >
                    <q-popup-proxy
                      transition-show="scale"
                      transition-hide="scale"
                    >
                      <q-color v-model="config.warning" />
                    </q-popup-proxy>
                  </q-icon>
                </template>
              </q-input>
            </q-item>
            <q-item>
              <q-item-label header>Choose the color if the action is overdue</q-item-label>
              <q-input
                filled
                v-model="config.overdue"
                class="my-input"
              >
                <template v-slot:append>
                  <q-icon
                    name="colorize"
                    class="cursor-pointer"
                  >
                    <q-popup-proxy
                      transition-show="scale"
                      transition-hide="scale"
                    >
                      <q-color v-model="config.overdue" />
                    </q-popup-proxy>
                  </q-icon>
                </template>
              </q-input>
            </q-item>
            <q-item>
              <q-item-label header>Choose the color of a patient with an emergency / called for help</q-item-label>
              <q-input
                filled
                v-model="config.emergency"
                class="my-input"
              >
                <template v-slot:append>
                  <q-icon
                    name="colorize"
                    class="cursor-pointer"
                  >
                    <q-popup-proxy
                      transition-show="scale"
                      transition-hide="scale"
                    >
                      <q-color v-model="config.emergency" />
                    </q-popup-proxy>
                  </q-icon>
                </template>
              </q-input>
            </q-item>
          </q-list>
        </div>
      </q-card-section>
      <q-card-actions
        align="right"
        class="text-primary"
      >
        <q-btn
          flat
          label="Cancel"
          @click="cancel()"
        />
        <q-btn
          flat
          label="Apply Settings"
          @click="confirm()"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
export default {
  name: 'Settings',
  props: {
    showSettings: Boolean,
    config: Object
  },
  data () {
    return {}
  },
  methods: {
    cancel () {
      this.$emit('cancel')
    },
    confirm () {
      this.$emit('apply')
    }
  }
}
</script>
